package com.caimei.controller.products;

import com.caimei.entity.CmMallCart;
import com.caimei.entity.CmMallOperationUser;
import com.caimei.entity.CmWxJsonModel;
import com.caimei.service.products.ShoppingService;
import com.caimei.service.user.LoginService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.Map;

/**
 * 购物车页面
 */
@Controller
@RequestMapping("/shopping")
public class ShoppingController {
    @Autowired
    private ShoppingService shoppingService;
    @Autowired
    private LoginService loginService;

    /**
     * 购物页数据
     */
    @ResponseBody
    @RequestMapping("/cart")
    public CmWxJsonModel cart(Integer userID, Integer organizeID, Integer index, Integer pageSize) {
        CmWxJsonModel model = CmWxJsonModel.newInstance();
        if (index == null) index = 1;
        if (pageSize == null) pageSize = 10;
        Map<String, Object> map = shoppingService.findAllCart(userID, index, pageSize);
        return model.success(map);
    }

    /**
     * 更新商品数量
     */
    @ResponseBody
    @RequestMapping("/update")
    public void updateNumber(CmMallCart cmMallCart) {
        shoppingService.updateNumber(cmMallCart);
    }

    /**
     * 删除购物车商品
     *
     * @return
     */
    @ResponseBody
    @RequestMapping("/delete")
    public CmWxJsonModel deleteCart(Integer userID, String productIDs, HttpServletRequest request) {
        CmWxJsonModel model = CmWxJsonModel.newInstance();
        HttpSession session = request.getSession();
        String openid = (String) session.getAttribute("openid");
        Integer organizeID = (Integer) session.getAttribute("organizeID");
        CmMallOperationUser operationUser = loginService.doLogin(openid, organizeID);
        if (operationUser == null) return model.error("账户异常");
        try {
            shoppingService.deleteCart(userID, productIDs);
        } catch (Exception e) {
            return model.error("删除失败");
        }
        return model.success("删除成功", "");
    }
}
